﻿namespace OverStore.Exceptions
{
    using System;

    /// <summary>
    /// Exception that is thrown when a persisting operation can't be executed correctly because 
    /// persistnce session is missing configuration part for such operation for specific type.
    /// </summary>
    public class PersistenceOperationIsNotSupportedException : NotSupportedException
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="PersistenceOperationIsNotSupportedException"/> class.
        /// </summary>
        public PersistenceOperationIsNotSupportedException()
            : base()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="PersistenceOperationIsNotSupportedException"/> class.
        /// </summary>
        /// <param name="message">The message.</param>
        public PersistenceOperationIsNotSupportedException(string message)
            : base(message)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="PersistenceOperationIsNotSupportedException"/> class.
        /// </summary>
        /// <param name="message">The error message that explains the reason for the exception.</param>
        /// <param name="innerException">The exception that is the cause of the current exception. If the <paramref name="innerException"/> parameter is not a null reference, the current exception is raised in a catch block that handles the inner exception.</param>
        public PersistenceOperationIsNotSupportedException(string message, Exception innerException)
            : base(message, innerException)
        {
        }
    }
}
