﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;

namespace OverStore.Runtime.ObjectRepository.Attacher
{
    /// <summary>
    /// Provides an additional info for instance being attached is required to correctly store instance.
    /// </summary>
    /// <typeparam name="TInstance">The type of the instance.</typeparam>
    /// <typeparam name="TIdentifier">The type of the identifier.</typeparam>
    public interface IAttacher<TInstance, TIdentifier> : IRuntimeComponent
        where TInstance : class
    {
        /// <summary>
        /// Provides the info for attaching instance.
        /// </summary>
        void ProvideAttachInfo(TInstance instance, InstanceAttachInfo<TIdentifier> attachInfo);
    }
}
