﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;

namespace OverStore.Scoping.Manager
{
    /// <summary>
    /// Contains event data for <see cref="OperationScopeManager.ScopeExited"/>
    /// </summary>
    public sealed class OperationScopeActionEventArgs : EventArgs
    {
        /// <summary>
        /// Gets or sets the current operation scope.
        /// </summary>
        public object CurrentScope { get; internal set; }

        /// <summary>
        /// Gets or sets the action that ends <see cref="T:OverStore.Transactions.OperationScope"/> lifecycle.
        /// </summary>
        public OperationScopeAction Action { get; internal set; }
    }
}
