﻿namespace OverStore.Sql.TableSchema
{
    using System;

    /// <summary>
    /// Represent a table column of table-based storage
    /// </summary>
    public class Column<T> : ColumnBase
    {
        /// <summary>
        /// When overriden in derived classes, returns actual column role in table.
        /// </summary>
        public override ColumnType ColumnType
        {
            get
            {
                return ColumnType.Regular;
            }
        }

        /// <summary>
        /// Gets or sets the CLR type of result stored in column.
        /// </summary>
        public override Type ClrType
        {
            get
            {
                return typeof(T);
            }
        }
    }
}